"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectableProxy = exports.InjectCls = void 0;
const common_1 = require("@nestjs/common");
const cls_service_1 = require("./cls.service");
const proxy_provider_1 = require("./proxy-provider");
/**
 * Use to explicitly inject the ClsService
 */
function InjectCls() {
    return (0, common_1.Inject)(cls_service_1.ClsService);
}
exports.InjectCls = InjectCls;
/**
 * Mark a Proxy provider with this decorator to distinguish it from regular NestJS singleton providers
 */
function InjectableProxy() {
    return (target) => (0, common_1.Injectable)()((0, common_1.SetMetadata)(proxy_provider_1.CLS_PROXY_METADATA_KEY, true)(target));
}
exports.InjectableProxy = InjectableProxy;
//# sourceMappingURL=cls.decorators.js.map