"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClsPluginManager = void 0;
const cls_service_globals_1 = require("../cls-service.globals");
class ClsPluginManager {
    static add(plugins = []) {
        this.plugins.push(...plugins);
    }
    static getPlugins() {
        return this.plugins;
    }
    static getPluginImports() {
        return this.plugins.flatMap((plugin) => { var _a; return (_a = plugin.imports) !== null && _a !== void 0 ? _a : []; });
    }
    static getPluginProviders() {
        return this.plugins.flatMap((plugin) => { var _a; return (_a = plugin.providers) !== null && _a !== void 0 ? _a : []; });
    }
    static async onClsInit() {
        var _a;
        for (const plugin of this.plugins) {
            await ((_a = plugin.onClsInit) === null || _a === void 0 ? void 0 : _a.call(plugin, this.clsService));
        }
    }
    static async onModuleInit() {
        var _a;
        for (const plugin of this.plugins) {
            await ((_a = plugin.onModuleInit) === null || _a === void 0 ? void 0 : _a.call(plugin));
        }
    }
    static async onModuleDestroy() {
        var _a;
        for (const plugin of this.plugins) {
            await ((_a = plugin.onModuleDestroy) === null || _a === void 0 ? void 0 : _a.call(plugin));
        }
    }
}
exports.ClsPluginManager = ClsPluginManager;
ClsPluginManager.clsService = cls_service_globals_1.globalClsService;
ClsPluginManager.plugins = [];
//# sourceMappingURL=cls-plugin-manager.js.map